<template>
  <div class="card-survey">
    <v-card
      class="cards"
      outlined
    >
      <v-list-item>
        <v-row justify="center" align="center">
          <v-col cols="1">
            <v-img
              src="/static/icon-book.svg"
            />
          </v-col>
          <v-col cols="4">
            <v-list-item-content>
              <v-list-item-title v-if="detail" class="card-survey-name" >{{ detail.survey_name }}</v-list-item-title>
              <v-list-item-subtitle class="periode">
                {{ $t('label.date') }} : {{ formatDatetime(detail.periode_start, 'DD MMMM YYYY') }} - {{ formatDatetime(detail.periode_end, 'DD MMMM YYYY') }}
              </v-list-item-subtitle>
            </v-list-item-content>
          </v-col>
          <v-col cols="2">
            <v-list-item-content>
              <v-chip
                class="status"
                color="#EEFBF4"
                text-color="green"
              >
                <v-avatar
                  left
                  class="green"
                />
                {{ detail.status ? detail.status : '-' }}
              </v-chip>
            </v-list-item-content>
          </v-col>
          <v-col cols="4">
            <div v-if="detail.respondent_target">
              <div>
                <div style="float: left;">{{ $t('label.target') }}</div>
                <div style="float: right;">
                  {{ detail.respondent_target ? detail.respondent_target : '-' }}
                </div>
              </div>
              <v-progress-linear
                class="target"
                color="green"
                rounded
                value="50"
              />
            </div>
            <div v-else style="display: -webkit-box;">
              <div class="card-respondent-target">{{ detail.respondent_target }}</div>
              <div class="card-description-answer">{{ $t('label.respondent_answer') }}</div>
            </div>
          </v-col>
          <v-col cols="1">
            <v-card-actions>
              <v-menu
                :close-on-content-click="false"
                :nudge-width="200"
                :nudge-left="220"
                :nudge-top="40"
                offset-y
              >
                <template v-slot:activator="{ on }">
                  <v-btn
                    class="ma-2"
                    tile
                    large
                    color="grey"
                    icon
                    v-on="on"
                  >
                    <v-icon>more_horiz</v-icon>
                  </v-btn>
                </template>
                <v-card>
                  <v-list-item @click="onResultsSurvey(detail.id)">
                    <img src="/static/icon-survey-results.svg" style="padding-right: 1rem;"> Hasil Survei
                  </v-list-item>
                  <v-list-item @click="handleEdit(detail.id)">
                    <img src="/static/update-it-survey.svg" style="padding-right: 1rem;"> Perbarui Survei
                  </v-list-item>
                  <v-list-item @click="handleCopyUrl(detail.id)">
                    <img src="/static/update-it-survey.svg" style="padding-right: 1rem;"> Salin URL Survei
                  </v-list-item>
                  <v-divider style="margin:0 !important;"/>
                  <v-list-item style="color: #EB5757 !important;" @click="handleDelete(detail.id)">
                    <img src="/static/icon-delete.svg" style="padding-right: 1rem;"> Hapus Survei
                  </v-list-item>
                </v-card>
              </v-menu>
            </v-card-actions>
          </v-col>
        </v-row>
      </v-list-item>
    </v-card>
    <input id="copy-url" type="hidden">
    <dialog-delete
      :dialog="dialog"
      :data-deleted="dataDelete"
      :store-path-delete="`survey/deleteSurvey`"
      :store-path-reset-list="`survey/resetListSurvey`"
      :store-path-get-list="`survey/getListSurvey`"
      :dialog-delete.sync="dialog"
      :deleted-data.sync="dataDelete"
    />
  </div>
</template>

<script>
import { formatDatetime } from '@/utils/parseDatetime'
import { baseUrl } from '@/utils/constantVariable'

export default {
  name: 'SurveyCard',
  props: {
    detail: {
      type: Object,
      default: null
    }
  },
  data() {
    return {
      dialog: false,
      dataDelete: null
    }
  },
  methods: {
    formatDatetime,
    async handleEdit(id) {
      await this.$store.dispatch('survey/detailSurvey', id)
      await this.$store.dispatch('survey/getQuestionsBySurvey', id)
      await this.$router.push('/survey/edit')
    },
    async handleDelete(id) {
      this.dialog = true
      this.dataDelete = {
        'id': id,
        'status': 'Deleted'
      }
    },
    async onResultsSurvey(id) {
      await this.$store.dispatch('survey/detailSurvey', id)
      const params = { id_survey: id, limit: 10 }
      await this.$store.dispatch('survey/getResponseSurvey', params)
      await this.$router.push('/survey/results')
    },
    async handleCopyUrl(id) {
      const response = await this.$store.dispatch('survey/detailSurvey', id)
      const url_survey = await `${baseUrl()}/#/form/s/r?key=${response.data.url}`

      document.getElementById('copy-url').value = url_survey

      const testingCodeToCopy = await document.querySelector('#copy-url')
      await testingCodeToCopy.setAttribute('type', 'text')
      await testingCodeToCopy.select()
      try {
        await document.execCommand('copy')
        await this.$store.dispatch('toast/successToast', this.$t('success.copy_url_succses'))
      } catch (err) {
        await this.$store.dispatch('toast/errorToast', this.$t('success.copy_url_errors'))
      }

      /* unselect the range */
      testingCodeToCopy.setAttribute('type', 'hidden')
      window.getSelection().removeAllRanges()
    }
  }
}
</script>
